"""
-*- coding: utf-8 -*-
@Author: huchl
@Time: 2024/3/25 上午9:30
@File: domain-clear-redis.py
@Desc: 清理redis缓存数据
"""
import sys
import redis

hash_tables = ['client_channel_name', 'actives', 'device_user_active', 'remote_assist', 'web_channel_name']


def clean_redis(ip, port, db_num=3):
    print(f"redis中ip为{ip}，端口为{port}, 数据库为{db_num}")
    r = redis.Redis(host=ip, port=port, db=db_num)

    for hash_table in hash_tables:
        if r.hlen(hash_table) > 0:
            r.delete(hash_table)
            print(f"Hash table '{hash_table}' has been deleted successfully.")
        else:
            print(f"Hash table '{hash_table}' does not exist or is empty.")

    r.connection_pool.disconnect()


if __name__ == "__main__":
    if len(sys.argv) < 3:
        print("Usage: python domain-clear-redis.py <Redis_IP> <Port>")
        sys.exit(1)

    ip = sys.argv[1]
    port = int(sys.argv[2])

    clean_redis(ip, port)
