"""
-*- coding: utf-8 -*-
@Author: huchl
@Time: 2023/8/4 下午5:14
@File: tasks.py
@Desc: 
"""
import datetime
import logging

from celery import shared_task
from django.db import close_old_connections

from utils.sch_soap_task_member import SoapMember

logger = logging.getLogger(__name__)


@shared_task
def synchro_data_soap(num=0):
    """定时数据同步任务"""
    start_time = datetime.datetime.now()
    soap_member = SoapMember(url_choice=1)
    connect_code = soap_member.client.connect()
    res_data_delete = []
    if connect_code != 1:
        logger.info(f"SOAP 服务连接异常")
    else:
        if num == 1:
            res_data = soap_member.get_member_all()
        else:
            res_data, res_data_delete = soap_member.get_member_day()
            logger.info(f"获取增量数据 修改数据{len(res_data)}，删除数据{len(res_data_delete)}")
        end_time = datetime.datetime.now()
        logger.info(f"获取本轮SOAP数据花费时间 {end_time-start_time}")
        logger.info(f"本轮SOAP数据同步数据总数 {len(res_data)}")
        soap_code1, soap_msg1 = soap_member.update_organ_to_db()
        if soap_code1 != 200:
            logger.info(f'同步webservice服务数据中，部门数据同步失败，错误提示为{soap_msg1}')
            raise ValueError(f'同步webservice服务数据中，部门数据同步失败，错误提示为{soap_msg1}')
        soap_code2, soap_msg2 = soap_member.update_user_to_db_freeipa(res_data)
        if soap_code2 != 200:
            logger.info(f'同步webservice服务数据中，账号数据同步失败，错误提示为{soap_msg2}')
            raise ValueError(f'同步webservice服务数据中，账号数据同步失败，错误提示为{soap_msg2}')
        soap_code3, soap_msg3 = soap_member.delete_user_to_db_freeipa(res_data_delete)
        if soap_code3 != 200:
            logger.info(f'同步webservice服务数据中，删除账号数据同步失败，错误提示为{soap_msg3}')
            raise ValueError(f'同步webservice服务数据中，删除账号数据同步失败，错误提示为{soap_msg3}')
        res_recodes = soap_msg3
        soap_member.append_recodes_to_db(res_recodes)
        # 更新部门名称
        soap_member.update_freeipa_name()
        logger.info(f"SOAP 数据同步成功")
        end_time = datetime.datetime.now()
        logger.info(f"本轮SOAP数据同步花费时间 {end_time - start_time}")

    close_old_connections()
