from django_redis import get_redis_connection
import json
import threading
from browser.util import update_jids,preAddPolicyAccountInfo,check_account_org_change,deploy_policy_to_device
import logging
logger = logging.getLogger(__name__)

def BrowserPolicyChannelWorker(subscribes):
    '''
    reprepro channel worker

    '''
    redis_sub = subscribes.subscribe(chan='browser_policy_chan')
    for recv in redis_sub.listen():
        data = json.loads(recv.get("data").decode('utf-8'))
        logger.info(f"Redis收到事件 recv data {data}")
        if data['event'] == "preAddPolicyAccountInfo":
            logger.info(f"账户-设备绑定变化事件处理")
            # preAddPolicyAccountInfo(data['account_id'])
            t = threading.Thread(target=preAddPolicyAccountInfo,args=(data['account_id'],data['org_id'],data['add_account_ids'],data['device_id'],))
            t.start()
        if data['event'] == "check_account_org_change":
            logger.info(f"账户-机构变化事件处理")
            # check_account_org_change(data['account_id'],data['org_id'])
            t = threading.Thread(target=check_account_org_change,args=(data['account_id'],data['org_id'],))
            t.start()
        if data['event'] == "browser_deploy_policy":
            logger.info(f"下发策略文件后JID更新事件处理")
            # update_jids(data['account_id'],data['policy_type'],data['jid'])
            if data['policy_id'] == 0 and data['update_seq'] == 0:
                 logger.info(f"终端开机执行策略下发事件")
            else:
                t = threading.Thread(target=update_jids,args=(data['account_id'],data['policy_type'],data['jid'],))
                t.start()
        if data['event'] == "browser_policy_delete":
            logger.info("#####################browser policy delete########################")
        if data['event'] == "save_device_domain_info_to_reids":
            logger.info(f"加域后事件处理")
            # deploy_policy_to_device(data['device_id'])
            t = threading.Thread(target=deploy_policy_to_device,args=(data['device_id'],))
            t.start()

            
 
       
      