
from django.utils import timezone
from browser import models
from devices.models import Devices
from saltapi.models import SaltJidDevice
import logging
logger = logging.getLogger(__name__)
 #浏览器策略下发状态完成情况定时查询
    # scheduler.add_job(query_browser_policy_status, 'interval', minutes=1, coalesce=True, max_instances=1)
 #scheduler task 
def query_browser_policy_status():
     
    count_account_policy_log()

    #    (0, '下发中'), (1, '成功 '), (2, '失败'), (3, '未应用/默认')
    count_status(models.BrowserUserPolicyAccount.objects.filter(status=0),0) 
    count_status(models.BrowserApplicationPolicyAccount.objects.filter(status=0),1) 
    count_status(models.BrowserBookmarkPolicyAccount.objects.filter(status=0),2) 

    delete_unbind_account()

    check_start_log(models.BrowserUserPolicyAccount.objects.filter(status=2),0) 
    check_start_log(models.BrowserApplicationPolicyAccount.objects.filter(status=2),1) 
    check_start_log(models.BrowserBookmarkPolicyAccount.objects.filter(status=2),2)
    # 补充因定时任务和salt时间间隔短 日志未查询到问题
    re_count_account_policy_log()

def count_account_policy_log(): 
    un_logs = models.BrowserPolicyLog.objects.filter(success__isnull=True)
    for policy_log in un_logs:
        jobid = policy_log.jobid
        saltJidDevice = SaltJidDevice.objects.filter(jid=jobid).first()
        
        if saltJidDevice:
            policy_log.fun = saltJidDevice.fun
            policy_log.fun_args = saltJidDevice.fun_args
            policy_log.minion = saltJidDevice.minion
            policy_log.ret = saltJidDevice.ret
            policy_log.full_ret = saltJidDevice.full_ret
            policy_log.success = saltJidDevice.success
        else:
            policy_log.success=0
        policy_log.save(force_update=True)


def re_count_account_policy_log(): 
    current_time = timezone.now()
    ten_minutes_ago  = current_time - timezone.timedelta(minutes=10)
    un_logs = models.BrowserPolicyLog.objects.filter(success=0,created_at__range=(ten_minutes_ago,current_time))
    for policy_log in un_logs:
        jobid = policy_log.jobid
        saltJidDevice = SaltJidDevice.objects.filter(jid=jobid).first()
        if saltJidDevice:
            policy_log.fun = saltJidDevice.fun
            policy_log.fun_args = saltJidDevice.fun_args
            policy_log.minion = saltJidDevice.minion
            policy_log.ret = saltJidDevice.ret
            policy_log.full_ret = saltJidDevice.full_ret
            policy_log.success = saltJidDevice.success
            policy_log.update_seq = 0
            policy_log.save(force_update=True)

def delete_unbind_account():
    policyAccounts = models.BrowserUserPolicyAccount.objects.all()
    for pa in policyAccounts: 
        account_id = pa.account_id
        bind_devices =   Devices.objects.exclude(is_domain=0).all().filter(bind_account=account_id) 
        if not bind_devices:
            pa.delete()
            logger.info(f"account {account_id} not bind device ,delete it done")
    policyAccounts = models.BrowserApplicationPolicyAccount.objects.all()
    for pa in policyAccounts: 
        account_id = pa.account_id
        bind_devices =   Devices.objects.exclude(is_domain=0).all().filter(bind_account=account_id) 
        if not bind_devices:
            pa.delete()
            logger.info(f"account {account_id} not bind device ,delete it done")
    policyAccounts = models.BrowserBookmarkPolicyAccount.objects.all()
    for pa in policyAccounts: 
        account_id = pa.account_id
        bind_devices =   Devices.objects.exclude(is_domain=0).all().filter(bind_account=account_id) 
        if not bind_devices:
            pa.delete()
            logger.info(f"account {account_id} not bind device ,delete it done")

def check_start_log(list,policy_type):
    if not list:
        return
    for item in list:
        all_device_item = models.BrowserPolicyLog.objects.filter(policy_type=policy_type,account_id=item.account_id,update_seq=item.update_seq)
        for p_log in all_device_item:
            if p_log.success == 0:
                s_log = models.BrowserPolicyLog.objects.filter(policy_type=policy_type,account_id=item.account_id,update_seq=0, 
                                                       device_hostname=p_log.device_hostname,
                                                       created_at__gt=p_log.created_at).order_by('-created_at').first()
                if s_log:
                    s_log.update_seq=item.update_seq
                    s_log.save()
                    logger.info(f"更新了一条开机策略记录到SEQ {item.update_seq}")
                    count_status(list,policy_type)
def count_status(list,policy_type):
    if not list:
         return
    for item in list: 
        status = 2 
        device_dict = {}
        all_device_item = models.BrowserPolicyLog.objects.filter(policy_type=policy_type,account_id=item.account_id,
                                                                 update_seq=item.update_seq).order_by('created_at')
        for p_log in all_device_item:
            device_dict[p_log.device_hostname]=p_log.success
            # logger.info(f"device_dict is {device_dict}")
        containe_zero = any(v==0 for v in device_dict.values())
        if containe_zero:
            status = 2
        else:
            status = 1
        # logger.info(f"status is {status}")
        item.status = status
        item.save()