from django.conf.urls import url, include
from browser import views
from rest_framework.routers import DefaultRouter

router = DefaultRouter()

router.register('user/default', views.BrowserUserPolicyDefaultViewSet, basename='默认用户策略信息1')
router.register('user/info', views.BrowserUserPolicyInfoViewSet, basename='用户策略信息1')
router.register('user/account', views.BrowserUserPolicyAccountViewSet, basename='用户策略信息-ACCOUNT1')

router.register('application/default', views.BrowserApplicationPolicyDefaultViewSet,
                basename='默认浏览器-应用策略 信息')
router.register('application/info', views.BrowserApplicationPolicyInfoViewSet, basename='浏览器-应用策略信息')
router.register('application/account', views.BrowserApplicationPolicyAccountViewSet, basename='浏览器-应用策略-ACCOUNT')

router.register('bookmark/default', views.BrowserBookmarkPolicyDefaultViewSet, basename='默认用户策略信息2')
router.register('bookmark/info', views.BrowserBookmarkPolicyInfoViewSet, basename='用户策略信息2')
router.register('bookmark/account', views.BrowserBookmarkPolicyAccountViewSet, basename='用户策略信息-ACCOUNT2')

urlpatterns = [
    url(r'^', include(router.urls)),
]
