from django.conf.urls import url
from django.urls import include
from rest_framework.routers import DefaultRouter

from camanager import views

router = DefaultRouter()

router.register('default', views.CaInfoViewSet, basename='默认CA证书设置')

urlpatterns = [
    # 基本信息
    url(r'^/', include(router.urls)),
    url(r'^/info$', views.CAInfoList.as_view()),
    url(r'^/info/(?P<id>[0-9]+)$', views.CaInfoDetail.as_view()),
    # CA文件
    url(r'^/file/(?P<filename>[^/]+)$', views.CaFileUploadView.as_view()),
    # CA下发信息
    url(r'^/distribute$', views.CaDistributeList.as_view()),

    # 系统默认策略
    url(r'^/policy$', views.CAInfoPolicyList.as_view()),
    url(r'^/policy/(?P<ids>[^/]+)$', views.CAInfoPolicyList.as_view()),
    
    url(r'^/switch$', views.CAInfoPolicySwitch.as_view()),
    url(r'^/switch/(?P<switch>[^/]+)$', views.CAInfoPolicySwitch.as_view()),
]
