# -*- coding: utf-8 -*-
# 查询任务执行结果
import signal
from celery_task.celery import app

from celery.result import AsyncResult

def kill_task(task_id):
    result = AsyncResult(id=task_id, app=app)
    result.revoke(terminate=True, signal=signal.SIGKILL)

def get_celery_result(task_id):
    async_result = AsyncResult(id=task_id, app=app)
    if async_result.successful():
        result = async_result.get()
        # print(result)  # 打印任务结果
        return result
    elif async_result.failed():
        # print('任务失败')
        return 'FAILED'
    elif async_result.status == 'PENDING':
        # print('任务等待中被执行')
        return 'PENDING'
    elif async_result.status == 'RETRY':
        # print('任务异常后正在重试')
        return  'RETRY'
    elif async_result.status == 'STARTED':
        # print('任务已经开始被执行')
        return 'STARTED'

if __name__ == '__main__':
    async_result = AsyncResult(id=id, app=app)
    if async_result.successful():
        result = async_result.get()
        print(result)  # 打印任务结果
    elif async_result.failed():
        print('任务失败')
    elif async_result.status == 'PENDING':
        print('任务等待中被执行')
    elif async_result.status == 'RETRY':
        print('任务异常后正在重试')
    elif async_result.status == 'STARTED':
        print('任务已经开始被执行')