from django.conf.urls import url
from django.urls import include
from rest_framework.routers import DefaultRouter

from devices import views

router = DefaultRouter()

router.register('info', views.DevicesViewSet, basename='终端列表信息')
router.register('bind_accounts', views.BindAccountsViewSet, basename='终端绑定的账号')

urlpatterns = [
    url(r'^', include(router.urls)),
    url(r'^ping/', views.PingAPIView.as_view(), name='Ping'),
    url(r'^login/', views.Login.as_view(), name='Login'),
    url(r'^domain/$', views.DeviceDomain.as_view(), name='DeviceDomain_post'),
    url(r'^domain/(?P<task_id>\S+)/$', views.DeviceDomain.as_view(), name='DeviceDomain_get'),
    url(r'^init-hostname/(?P<device_uuid>\S+)/$', views.DeviceHostnameInit.as_view(), name='DeviceHostnameInit'),
    url(r'^domain-info/(?P<device_uuid>\S+)/$', views.DeviceDomainInfo.as_view(), name='DeviceDomainInfo'),
    url(r'^get-client/$', views.GetClient.as_view(), name='GetClient'),
    url(r'^get-client_2/$', views.GetClient2.as_view(), name='GetClient2'),
    url(r'^all/$', views.DeviceAll.as_view(), name='DeviceAll'),
    url(r'^count/$', views.DeviceCount.as_view(), name='DeviceCount'),
    url(r'^details-basic/(?P<id>[0-9]+)$', views.DeviceDetailsBasic.as_view(), name='DeviceDetailsBasic'),
    url(r'^details-hardware/(?P<id>[0-9]+)/$', views.DeviceDetailsHardware.as_view(), name='DeviceDetailsHardware'),
    url(r'^details-mount/(?P<id>[0-9]+)/$', views.DeviceDetailsMount.as_view(), name='DeviceDetailsMount'),
    url(r'^details-security/(?P<id>[0-9]+)/$', views.DeviceDetailsSecurity.as_view(), name='DeviceDetailsSecurity'),

    url(r'^sync/policy/(?P<device_uuid>\S+)/$', views.DeviceSyncPolicy.as_view(), name='DeviceSyncPolicy'),
]
