import os
import django
import openpyxl
from django.apps import apps

os.environ.setdefault("DJANGO_SETTINGS_MODULE", "nfs_domain_mainserver.settings")
django.setup()

wb = openpyxl.Workbook()

# for app_config in apps.get_app_configs():
#     models = app_config.get_models()
#     for model in models:
#         sheet = wb.create_sheet(title=model._meta.db_table)
#         fields = model._meta.fields
#         # for i, field in enumerate(fields):
#         #     sheet.cell(row=1, column=i+1, value=field.name)
#         row = 2
#         for i, field in enumerate(fields):
#             # print(field.__dict__)
#             # break
#             # print(str(field.verbose_name))
#             # print(type(field.verbose_name))
#             sheet.cell(row=1, column=1, value='字段名')  # 字段名
#             sheet.cell(row=1, column=2, value='字段注释')  # 字段名
#             sheet.cell(row=1, column=3, value='字段类型')  # 字段名
#
#             sheet.cell(row=row, column=1, value=field.name)  # 字段名
#             # sheet.cell(row=row, column=2, value=field.primary_key)  # 字段名
#             sheet.cell(row=row, column=2, value=str(field.verbose_name))  # 注释
#             # sheet.cell(row=row, column=3, value= '此字段能为空' if field.blank else '此字段不能为空')  # 是否可空
#             # sheet.cell(row=row, column=5, value=field.max_length)
#             sheet.cell(row=row, column=3, value=field.get_internal_type())
#             row += 1
l = []

def inr_table(wb):
    for app_config in apps.get_app_configs():
        models = app_config.get_models()
        for model in models:
            l.append({
                'model_name':model._meta.db_table,
                'verbose_name':model._meta.verbose_name
            })
            sheet = wb.create_sheet(title=model._meta.db_table)
            fields = model._meta.fields
            row = 2
            for i, field in enumerate(fields):
                # print(field.__dict__)
                # break
                # print(str(field.verbose_name))
                # print(type(field.verbose_name))
                sheet.cell(row=1, column=1, value='字段名')  # 字段名
                sheet.cell(row=1, column=2, value='字段注释')  # 字段名
                sheet.cell(row=1, column=3, value='字段类型')  # 字段名

                sheet.cell(row=row, column=1, value=field.name)  # 字段名
                # sheet.cell(row=row, column=2, value=field.primary_key)  # 字段名
                sheet.cell(row=row, column=2, value=str(field.verbose_name))  # 注释
                # sheet.cell(row=row, column=3, value= '此字段能为空' if field.blank else '此字段不能为空')  # 是否可空
                # sheet.cell(row=row, column=5, value=field.max_length)
                sheet.cell(row=row, column=3, value=field.get_internal_type())
                row += 1
    return wb

def all_table(wb):
    base_sheet = wb.get_active_sheet()
    row = 2
    num = 1
    base_sheet.cell(row=1, column=1, value='序号')  # 字段名
    base_sheet.cell(row=1, column=2, value='表名')  # 字段名
    base_sheet.cell(row=1, column=3, value='表名称(中文)')  # 字段名

    # for app_config in apps.get_app_configs():
    #     models = app_config.get_models()
    #
    #     for model in models:
    #         model_name = model._meta.model_name
    #         verbose_name = model._meta.verbose_name
    #         base_sheet.cell(row=row, column=1, value=num)  # 字段名
    #         base_sheet.cell(row=row, column=2, value=str(model_name))  # 字段名
    #         base_sheet.cell(row=row, column=3, value=str(verbose_name))  # 字段名
    #
    #         row += 1
    #         num += 1


    for model in l:
        model_name = model.get('model_name')
        verbose_name = model.get('verbose_name')
        base_sheet.cell(row=row, column=1, value=num)  # 字段名
        base_sheet.cell(row=row, column=2, value=str(model_name))  # 字段名
        base_sheet.cell(row=row, column=3, value=str(verbose_name))  # 字段名

        row += 1
        num += 1
    return wb

wb = inr_table(wb)
wb = all_table(wb)
wb.save('domain_table.xlsx')


'''
{'name': 'id', 'verbose_name': 'ID', '_verbose_name': 'ID', 'primary_key': True, 'max_length': None,
'_unique': False, 'blank': True, 'null': False, 'remote_field': None, 'is_relation': False,
'default': "<class 'django.db.models.fields.NOT_PROVIDED'>", 'editable': True, 'serialize': False,
'unique_for_date': None, 'unique_for_month': None, 'unique_for_year': None, 'choices': None, 'help_text': '',
'db_index': False, 'db_column': None, '_db_tablespace': None, 'auto_created': True, 'creation_counter': -71,
'_validators': [], '_error_messages': None, 'error_messages': {
    'invalid_choice': '值 %(value)r 不是有效选项。', 'null': '这个值不能为 null。', 'blank': '此字段不能为空。',
    'unique': '具有 %(field_label)s 的 %(model_name)s 已存在。',
    'unique_for_date': '%(field_label)s 必须在 %(date_field_label)s 字段查找类型为 %(lookup_type)s 中唯一。',
    'invalid': '“%(value)s” value must be an integer.'}, 'attname': 'id', 'column': 'id', 'concrete': True,
    'model': "<class 'messagenotice.models.MessageNoticeCenter'>"}

'''
