# python2
import subprocess
import sys

from SimpleXMLRPCServer import SimpleXMLRPCServer
from functools import wraps



def rpc_response(code, data):
    res = {'code':code,'data':data}
    return res

def auth_rpc_permission(func):
    @wraps(func)
    def is_auth(*args, **kwargs):
        if not args:
            return rpc_response(400, 'not permission')
        if args[-0] != 'nfs':
            return rpc_response(400, 'not permission')
        return func(*args)
    return is_auth


@auth_rpc_permission
def java_sm4_hash(auth, data):
    cmd_args = "java -cp Sm4Encrypt-1.6.jar:. NFSEncode '{0}'".format(data)
    print(cmd_args)
    result = subprocess.check_output(cmd_args, shell=True)
    print(result)
    return rpc_response(200,{'stdout': result.strip()})


@auth_rpc_permission
def java_sm4_decrypt(auth, data):
    cmd_args = "java -cp Sm4Encrypt-1.6.jar:. NFSDecode '{0}'".format(data)
    result = subprocess.check_output(cmd_args, shell=True)
    print(result)
    return rpc_response(200,{'stdout': result.strip()})


if __name__ == '__main__':
    print('*** start freeipa rpc ***')

    if len(sys.argv) == 1:
        port = '35252'
    else:
        port = sys.argv[-1]
    if not port.isdigit():
        raise Exception('port error not int')
    print('*** rpc freeipa port : {} '.format(port))

    server = SimpleXMLRPCServer(("0.0.0.0", 35252))

    server.register_function(java_sm4_hash)
    server.register_function(java_sm4_decrypt)
    server.serve_forever()