# -*- coding: utf-8 -*-

# gunicorn_config.py
import os
import multiprocessing

BASE_DIR = os.path.dirname(os.path.abspath(__file__))

LOG_DIR_PATH = os.path.join(os.path.dirname(BASE_DIR), "logs")
if not os.path.exists(LOG_DIR_PATH):
    os.makedirs(LOG_DIR_PATH)

bind = '0.0.0.0:8082'  # 绑定ip和端口号
backlog = 2048  # 监听队列
chdir = '/opt/domain/nfs-domain-mainserver/nfs_domain_mainserver'  # gunicorn要切换到的目的工作目录
timeout = 300  # 超时
worker_class = 'sync'  # 使用gevent模式，还可以使用sync 模式，默认的是sync模式
# worker_class = 'eventlet'

# 启动的工作进程数
workers = 10  # 进程数 websocket的两倍
# 每个工作进程的线程数
threads = 5
# 每个工作进程处理的最大请求数
max_requests = 1000
# 每个工作进程处理的最大请求抖动数
max_requests_jitter = 50

# LOG_DIR_PATH = os.path.join(os.path.dirname(BASE_DIR), "logs")
loglevel = 'info'  # 日志级别，这个日志级别指的是错误日志的级别，而访问日志的级别无法设置
# debug:调试级别，记录的信息最多；
# info:普通级别；
# warning:警告消息；
# error:错误消息；
# critical:严重错误消息；
access_log_format = '%(t)s %(p)s %(h)s "%(r)s" %(s)s %(L)s %(b)s %(f)s" "%(a)s"'
accesslog = "{}/web/gunicorn_access.log".format(LOG_DIR_PATH)  # 访问日志文件
errorlog = "{}/web/gunicorn_error.log".format(LOG_DIR_PATH)  # 错误日志文件
