# -*- coding: utf-8 -*-

from django.db import models


class MessageCenter(models.Model):
    content = models.TextField(verbose_name='消息内容', null=True, blank=True)
    create_time = models.DateTimeField(verbose_name='时间', null=True, blank=True)
    target_module = models.CharField('消息模块名', max_length=255, null=True, blank=True)
    message_user = models.CharField('消息所属用户', max_length=255, null=True, blank=True)
    message_device = models.CharField('消息所属设备', max_length=255, null=True, blank=True)
    download_path = models.TextField('文件下载路径', null=True, blank=True)
    is_read = models.SmallIntegerField(verbose_name='是否已读 0|未读， 1|已读', default=0, null=False, blank=True)
    is_broadcast = models.SmallIntegerField(verbose_name='是否是广播信息 0|不是， 1|是', default=0, null=False, blank=True)

    class Meta:
        db_table = 'message_center'
        verbose_name = '消息中心'
        verbose_name_plural = '消息中心'
