from channels.routing import ProtocolTypeRouter, URLRouter
from channels.auth import AuthMiddlewareStack
from django.conf.urls import url
from django.core.asgi import get_asgi_application
from saltapi.views import DomainEvent, ClientPing
from devices import web_consumers, client_consumers

urlpatterns = [
    # url(r'^domainevent/$', DomainEvent.as_asgi()),
    url(r'^client-ping/(?P<device_uuid>\S+)/$', ClientPing.as_asgi()),
    url(r'^cmdset/$', client_consumers.ClientConsumer.as_asgi()),  # 终端websocket接口
    url(r'^domainevent/$', web_consumers.WebConsumer.as_asgi()),  # 前端websocket接口
    # url(r'^client_set/$', client_consumers.ClientConsumer.as_asgi())  # 重构终端websocket
]

application = ProtocolTypeRouter({
    'http': get_asgi_application(),
    'websocket': AuthMiddlewareStack(URLRouter(urlpatterns))
})

# application = ProtocolTypeRouter({
#
#     'websocket': AllowedHostsOriginValidator(
#
#         AuthMiddlewareStack(
#
#             URLRouter(
#
#                 urlpatterns
#
#             )
#
#         )
#
#     )
#
# })
