from django.conf.urls import url, include
from django.contrib import admin
from django.views.static import serve
from django.conf import settings
from django.views.generic.base import TemplateView
from django.conf.urls.static import static
from devices.views import DownloadClient,DownloadClient2
from accounts.views import ApisAuth,ApisUpdatePWD


index_html = '{}/{}'.format(settings.FRONT_ROOT, "index.html")

urlpatterns = [
                  # url(r'^admin/', admin.site.urls),
                  url(r'^mainweb$', TemplateView.as_view(template_name=index_html)),

                  # api
                  url('mainapi/index/', include('index.urls')),
                  url('mainapi/user/', include('users.urls')),
                  url('mainapi/system/', include('system.urls')),
                  url('mainapi/device/', include('devices.urls')),
                  url('mainapi/salt/', include('saltapi.urls')),
                  url('mainapi/client/$', DownloadClient.as_view(), name='DownloadClient'),
                  url('mainapi/client_2/$', DownloadClient2.as_view(), name='DownloadClient2'),
                  url(r'mainapi/client/(?P<file>\S+)/$', DownloadClient.as_view(), name='DownloadClient'),
                  url(r'^mainapi/jobs/', include('jobs_management.urls')),
                  # url(r'^mainapi/tasks/', include('tasks.urls')),
                  url(r'^mainapi/filemanager/', include('filemanager.urls')),
                  url(r'^mainapi/remote_assists', include('remote_assist.urls')),
                  url(r'^mainapi/groups', include('groups.urls')),
                  url('mainapi/message_center/', include('message_center.urls')),
                  url('mainapi/patch/', include('patch_management.urls')),
                  url('mainapi/logs/', include('logs.urls')),
                  url('mainapi/reports/', include('reports.urls')),
                  url('mainapi/softwarecenter/', include('softwarecenter.urls')),
                  url('mainapi/adminlog/', include('adminlog.urls')),
                  url('mainapi/clientlog/', include('clientlog.urls')),
                  url('mainapi/sysios/', include('sysios.urls')),
                  url('mainapi/fileupload/', include('fileupload.urls')),

                  # client user
                  url('mainapi/account', include('accounts.urls')),
                  url('mainapi/org', include('organizations.urls')),
                  url('mainapi/software', include('software.urls')),
                  url('mainapi/ca', include('camanager.urls')),
                  url('mainapi/browser/policy/', include('browser.urls')),
                  # apis
                  url('apis/auth', ApisAuth.as_view(), name='ApisAuth'),
                  url('apis/password', ApisUpdatePWD.as_view(), name='ApisAuth'),
                  url(r'^mainapi/policy', include('policy.urls')),

                  # react fake view
                  url(r'^mainweb/(?P<path>.*)$', serve, {'document_root': settings.FRONT_ROOT}, name='frontend'),

                  url('media/(?P<path>.*)', serve, {'document_root': settings.MEDIA_ROOT}, name='media'),
                  url('mainapi/wallpaper/(?P<path>.*)', serve, {'document_root': settings.WALLPAPER_ROOT},
                      name='wallpaper'),
                  url('mainapi/(?P<path>.*)', serve, {'document_root': settings.SALTFILES_ROOT},
                      name='pre_add_domain'),
              ] + static(settings.STATIC_URL, document_root=settings.STATIC_ROOT)
