"""
-*- coding: utf-8 -*-
@Author: huchl
@Time: 2023/3/16 下午1:21
@File: serializers.py
@Desc: 部门序列化
"""

from rest_framework import serializers
from organizations.models import OrgnizationEntity, OrgLabel


class OrganSerializer(serializers.ModelSerializer):
    org_label = serializers.SerializerMethodField()

    class Meta:
        model = OrgnizationEntity
        fields = ('address', 'contact_phone', 'create_type', 'created_at', 'executive', 'id', 'last_update',
                  'name', 'parent', 'passwd_extra_status', 'remarks', 'seq_num', 'org_label')

    def get_org_label(self, obj):
        org_label_items = OrgLabel.objects.filter(org_id=obj.id)
        if org_label_items.exists():
            return org_label_items.first().org_label
        else:
            return None


class OrgLabelSerializer(serializers.ModelSerializer):
    class Meta:
        model = OrgLabel
        fields = '__all__'
