from django.conf.urls import url
from django.urls import include
from rest_framework.routers import DefaultRouter

from organizations import views

router = DefaultRouter()

router.register('/info', views.OrgansViewSet, basename='部门信息用列表信息')
router.register('/label', views.OrgLabelViewSet, basename='部门标信息接口')

urlpatterns = [
    url(r'^', include(router.urls)),
    url(r'^/account/(?P<oid>[0-9]+)$', views.OrganizationAccount.as_view()),
    url(r'^/executive/(?P<oid>[0-9]+)$', views.OrganizationExecutive.as_view()),
    url(r'^/tree_accounts$', views.OrganizationTreeListWithAccount.as_view()),
    url(r'^/tree$', views.OrganizationTreeList.as_view()),
    url(r'^/$', views. OrganizationList.as_view()),
    url(r'^/(?P<oid>[0-9]+)$', views. OrganizationDetail.as_view()),
    #批量导入
    url(r'^/batch/(?P<filename>[^/]+)$', views.OrganizationtBatch.as_view()),
    #批量导入模板下载
    url(r'^/batch/tmpl/(?P<filename>[^/]+)$', views.OrganizationBatchTmpl.as_view()),
    #ldap导入
    url(r'^/batch/ldap/(?P<filename>[^/]+)$', views.OrganizationBatchImportLDAP.as_view()),
    #导出excel
    url(r'^/export$', views.OrganizationExport.as_view()),

    # 部门批量加入或移除域用户
    url(r'^/org_batch_account_operation', views.org_batch_account_operation),

    # 部门批量加入或移除设备
    url(r'^/org_batch_device_operation', views.org_batch_device_operation),
]
