"""
-*- coding: utf-8 -*-
@Author: huchl
@Time: 2023/9/4 上午9:59
@File: filter.py
@Desc: 补丁管理的过滤条件
"""
from django_filters import rest_framework as filters
from patch_management import models
from devices.models import Devices


class PatchInfoFilter(filters.FilterSet):
    class Meta:
        model = models.PatchInfo
        fields = {
            "patch_name": ['exact', 'contains'],
            "patch_ver": ['exact', 'contains'],
            "patch_no": ['exact', 'contains'],
            "patch_source": ['exact', 'contains'],
            "patch_app_arch": ['exact', 'contains'],
            "patch_app_sys": ['exact', 'contains'],
            "patch_type": ['exact', 'contains'],
        }


class PatchSourceFilter(filters.FilterSet):
    class Meta:
        model = models.PatchSource
        fields = {
            "patch_source_name": ['exact', 'contains'],
            "patch_source_enable": ['exact', ]
        }


class PatchDevicesFilter(filters.FilterSet):
    class Meta:
        model = Devices
        fields = {
            "device_cnname": ['exact', 'contains'],
            "device_ip": ['exact', 'contains'],
            "org_info_id": ['exact', ],
            "is_up": ['exact', ],
        }


class PatchPolicyFilter(filters.FilterSet):
    class Meta:
        model = models.PatchPolicy
        fields = {
            "name": ['exact', 'icontains'],
            "status": ['exact', ],
            "creator": ['exact', 'icontains'],
        }
