"""
-*- coding: utf-8 -*-
@Author: huchl
@Time: 2023/9/4 上午9:54
@File: urls.py
@Desc: 补丁系统api路由
"""
from django.conf.urls import url, include
from patch_management import views
from rest_framework.routers import DefaultRouter

router = DefaultRouter()

router.register('patch_file', views.PatchFileViewSet, basename="补丁文件上传")
router.register('type_dict', views.PatchTypeDictViewSet, basename='补丁类型维护接口')
router.register('sys_dict', views.PatchSysDictViewSet, basename='补丁应用系统维护接口')
router.register('info', views.PatchInfoViewSet, basename='补丁信息列表')
router.register('source', views.PatchSourceViewSet, basename='补丁源信息列表')
router.register('device', views.PatchDevicesViewSet, basename='设备补丁信息')
router.register('patch_status', views.PatchDeviceLogViewSet, basename='终端补丁安装记录情况')
router.register('policy', views.PatchPolicyViewSet, basename='补丁策略信息')
router.register('policy_setting', views.PatchDeliverySettingsViewSet, basename='补丁策略下发设置')

urlpatterns = [
    url(r'^', include(router.urls)),

]
