import json
import logging
from django.db.models import signals
from django.dispatch import receiver
from django.db.models.signals import m2m_changed, post_save

from accounts.models import AccountEntity
from devices.models import Devices

logger = logging.getLogger(__name__)


@receiver(post_save, sender=AccountEntity)
def check_account_change(sender, instance, **kwargs):
    from policy.tasks import trigger_gpo_update
    logger.info("=========account_browser_signal_received========")
    logger.info(instance.id)
    trigger_gpo_update.delay([instance.id], [])
    return
@receiver(m2m_changed, sender=AccountEntity)
def check_account_org_change(sender, instance, **kwargs):
    from policy.tasks import trigger_gpo_update
    logger.info("=========account_org_browser_signal_received========")
    logger.info(instance)
    trigger_gpo_update.delay([instance.id], [])
    return

@receiver(post_save, sender=Devices)
def check_device_change(sender, instance, **kwargs):
    from policy.tasks import trigger_gpo_update
    logger.info("=========device_browser_signal_received========")
    logger.info(instance)
    trigger_gpo_update.delay([], [instance.id])
    return
@receiver(m2m_changed, sender=Devices)
def check_device_org_change(sender, instance, **kwargs):
    from policy.tasks import trigger_gpo_update
    logger.info("=========device_org_browser_signal_received========")
    logger.info(instance)
    trigger_gpo_update.delay([], [instance.id])
    return
