# -*- coding: utf-8 -*-

import logging
from devices.client_consumers import msg_to_client
from django_redis import get_redis_connection

logger = logging.getLogger(__name__)

redis_conn = get_redis_connection('redis')
    
def send_group_policys(device_hostname):

    logger.info(f"send group policys to {device_hostname}")
    send_msg = {'sender': 'SERVER', 'sn': None, 'data': None, 'message': None}
    send_msg.update({"message":"policy group infomation.","sn": "10-1-1", "data": {"version": "v1.0","msgid":"getmsgid","time":"time"
        ,"client_version":{"least":"1.0","latest":"1.9"},"service":"policy_group","policys":[]
    }})

    # TODO 需要接口 获取设备的策略列表
    send_msg['data']['policys'].append({"type":"usb","val":"off","code":10})
    send_msg['data']['policys'].append({"type":"root","val":"false","code":10})
    
    redis_channel_name = redis_conn.hget('client_channel_name',  device_hostname)
    if redis_channel_name:
        redis_channel_name = redis_channel_name.decode('utf-8')
        msg_to_client(1, redis_channel_name, send_msg)
    else:
        logger.info(f"not found  {device_hostname} in client_channel")