# -*- coding: utf-8 -*-

from django.db import models


class HistoryDeviceOnline(models.Model):
    device_uuid = models.CharField(verbose_name='关联终端设备', max_length=255, null=True, blank=True)
    up_time = models.DateTimeField(verbose_name='上线时间', auto_now_add=True, null=True, blank=True)
    down_time = models.DateTimeField(verbose_name='下线时间', auto_now_add=False, null=True, blank=True)

    class Meta:
        db_table = 'history_device_online'
        verbose_name = '历史数据:终端上下线'
        verbose_name_plural = '历史数据:终端上下线'
        
        # 自定义索引
        indexes = [
            models.Index(fields=['device_uuid'], name='idx_device_device_uuid'),
            models.Index(fields=['up_time'], name='idx_device_up_time'),
        ]


class HistoryAccountOnline(models.Model):
    account_name = models.CharField(verbose_name='终端用户唯一名', max_length=255, null=True, blank=True)
    up_time = models.DateTimeField(verbose_name='上线时间', auto_now_add=True, null=True, blank=True)
    down_time = models.DateTimeField(verbose_name='下线时间', auto_now_add=False, null=True, blank=True)
    device_uuid = models.CharField(verbose_name='关联终端设备', max_length=255, null=True, blank=True)

    class Meta:
        db_table = 'history_account_online'
        verbose_name = '历史数据:终端用户上下线'
        verbose_name_plural = '历史数据:终端用户上下线'

        # 自定义索引
        indexes = [
            models.Index(fields=['account_name'], name='idx_account_account_name'),
            models.Index(fields=['device_uuid'], name='idx_account_device_uuid'),
            models.Index(fields=['up_time'], name='idx_account_up_time'),
        ]