"""
-*- coding: utf-8 -*-
@Author: huchl
@Time: 2023/5/8 上午11:20
@File: filters.py
@Desc: 
"""
from django_filters import rest_framework as filters

from devices.models import Devices
from saltapi.models import PolicyInfo, ShellDevicePolicy, Shell


class PolicyInfoFilter(filters.FilterSet):
    class Meta:
        model = PolicyInfo
        fields = {
            'policy_name': ['exact', 'icontains'],
            'policy_create_user': ['exact', 'icontains'],
            'policy_run_status': ['exact']
        }

class ShellDevicePolicyFilter(filters.FilterSet):
    class Meta:
        model = Devices
        fields = {
            "device_cnname": ['exact', 'contains'],
            "device_ip": ['exact', 'contains'],
            "org_info_id": ['exact', ],
            "is_up": ['exact', ],
        }

class ShellFilter(filters.FilterSet):
    class Meta:
        model = Shell
        fields = {
            'name': ['exact', 'icontains'],
            'creator': ['exact', 'icontains'],
            'remark': ['exact', 'contains']
        }