from django.conf.urls import url
from django.urls import include
from rest_framework.routers import DefaultRouter
from software import views

router = DefaultRouter()
router.register('/policy', views.SoftwarePolicyViewSet, basename='软件策略信息')
router.register('/softwareinfo', views.SoftwareInfoViewSet, basename='软件信息列表')

urlpatterns = [
    # 基本信息
    url(r'^/deb/(?P<filename>[^/]+)$', views.DebUploadView.as_view()),
    url(r'^/info/$', views.SoftwareInfoList.as_view()),
    url(r'^/info/(?P<sid>[0-9]+)$', views.SoftwareInfoDetail.as_view()),
    # 软件批量删除
    url(r'^/software_batch_delete/$', views.software_batch_delete),
    # 默认策略相关
    url(r'^/default$', views.DefaulInstalledSoftwareInfos.as_view()),
    url(r'^/default/(?P<sid>[0-9]+)$', views.DefaulInstalledSoftwareInfoDetail.as_view()),
    # 软件安装
    url(r'^/single$', views.SoftwareSingleInstall.as_view()),
    url(r'^/batch$', views.SoftwareBatchInstall.as_view()),
    # 终端软件安装信息
    url(r'^/installed/(?P<did>[0-9]+)$', views.SoftwareInstalledList.as_view()),
    # 终端信息
    url(r'^/devices$', views.DeviceInfos.as_view()),
    # 软件类型
    url(r'^/type/$', views.SoftwareTypeAPIView.as_view()),
    # 软件适配系统
    url(r'^/os/$', views.SoftwareOSAPIView.as_view()),
    # 软件适配架构
    url(r'^/arch/$', views.SoftwareArchAPIView.as_view()),
    # 软件源
    url(r'^/source/$', views.SoftwareSourceAPIView.as_view()),
    # 软件源批量更新启用禁用
    url(r'^/source/source_update_status/', views.source_update_status),
    # 连接测试软件源
    url(r'^/test_software_source/', views.test_software_source),
    # 同步软件源
    url(r'^/sync_software_source/', views.sync_software_source),
    # 下发软件任务
    url(r'^/add_software_task/', views.add_software_task),

    url(r'^', include(router.urls)),
]
