# -*- coding: utf-8 -*-
# import logging
# from fdfs_client.client import Fdfs_client
#
#
# logger = logging.getLogger(__name__)
#
# class FdfsClient:
#     """
#     FDFS客户端
#     """
#     def __init__(self):
#         tracker_conf_path = "./fdfs_tracker.conf"  # tracker配置文件的地址
#         self.client = Fdfs_client(client=tracker_conf_path)
#
#     def upload_by_filename(self, file_path):
#         '''
#         文件上传
#         当有一个文件在本地磁盘上，并且知道文件的路径时，可以使用这个方法
#         :param file: 文件路径
#         :return:
#         {
#             'Group name': 'group1', 'Remote file_id': 'group1/M00/00/00/PAo80GdNlk0AAAABAwXgAHrGIgk207.iso',
#             'Status': 'Upload successed.', 'Local file name': '/home/wangxiuyan/06-vm/ios/Kylin-Server-10-SP2-x86-Release-Build09-20210524.iso',
#             'Uploaded size': '4.05GB', 'Storage IP': '60.10.60.208'
#         }
#         '''
#         ret = self.client.upload_by_filename(file_path)
#         logger.info(f"ret={ret}")
#         return ret
#
#     def upload_by_buffer(self, file_buffer, file_name):
#         '''
#         文件上传
#         当已经将文件读取到内存中（例如从网络下载的数据、从数据库获取的数据等），或者直接上传内存中的数据时，可以使用这个方法
#         :param file_buffer: 文件二进制内容
#         :param file_name: 文件名
#         :return:
#         '''
#         ret = self.client.upload_by_buffer(file_buffer, file_name)
#         print(ret)
#         return ret
#
#     def delete_file(self, file_id):
#         '''
#         删除文件
#         :param file_id: 文件在fastDFS中的 Remote file_id
#         :return:
#         '''
#         ret = self.client.delete_file(file_id)
#         logger.info(f"ret={ret}")
#         return ret
#
#     def download_file(self, save_path, file_id):
#         '''
#         下载文件
#         :param save_path: 文件保存路径
#         :param file_id: 文件在fastDFS中的 Remote file_id
#         :return:
#         '''
#         ret = self.client.download_file(save_path, file_id)
#         logger.info(f"ret={ret}")
#         return ret
#
#     def get_all_groups(self):
#         ret = self.client.get_all_groups()
#         logger.info(f"ret={ret}")
#         return ret