# -*- coding: utf-8 -*-
from django.conf.urls import url
from django.urls import include
from rest_framework.routers import DefaultRouter
from sysios import views

router = DefaultRouter()

router.register(r'iso', views.SysiosIsoViewSet, basename='镜像管理')
router.register(r'factory', views.SysiosFactoryViewSet, basename='系统厂商管理')
router.register(r'arch', views.SysiosArchViewSet, basename='系统架构管理')
router.register(r'language', views.SysiosLanguageViewSet, basename='系统语言管理')
router.register(r'keyboard', views.SysiosKeyboardViewSet, basename='系统键盘布局管理')
router.register(r'timezone', views.SysiosTimezoneViewSet, basename='系统时区管理')

urlpatterns = [
    url(r'^', include(router.urls)),
    # 文件管理
    url(r'^file/upload/', views.FileUploadViewSet.as_view(), name='文件上传'),
    url(r'^file/download/(?P<file_id>[0-9]+)/$', views.FileDownloadViewSet.as_view(), name='文件下载'),
]
