from django.conf.urls import url
from django.urls import include
from rest_framework.routers import DefaultRouter

from system import views

router = DefaultRouter()

router.register('terminal', views.TerminalConfigViewSet, basename='终端系统配置')
router.register('domain_rule', views.DomainRuleViewSet, basename='加域规则设置')
router.register('nginx_limit', views.DeviceLimitViewSet, basename='客户端限速设置')
router.register('device_opt', views.DeviceOTPViewSet, basename='客户端卸载认证口令')
router.register('device_stats', views.DeviceStatsViewSet, basename='终端纳管统计设置')

urlpatterns = [
    url(r'^', include(router.urls)),
    url(r'^config/$', views.SystemConfig.as_view(), name='SystemConfigs'),
]
