from django.conf.urls import url
from django.urls import include
from rest_framework.routers import DefaultRouter

from tasks import views
from tasks.views import TasksViewSet, TasksListViewSet, TaskDeviceExecViewSet, schedule_task, task_detail_device

router = DefaultRouter()

router.register('tasks_info', views.TasksInfoViewSet, basename='任务信息接口')

urlpatterns = [
    url(r'^', include(router.urls)),
    url(r'^task/$', TasksViewSet.as_view(), name='Tasks'),
    url(r'^task/(?P<task_id>[0-9]+)/$', TasksViewSet.as_view(), name='Tasks'),
    url(r'^task_list/$', TasksListViewSet.as_view(), name='TasksList'),
    url(r'^task_device_exec/$', TaskDeviceExecViewSet.as_view(), name='task_device_exec'),
    url(r'^task_detail_device/', task_detail_device),
    # 任务暂停
    url(r'^schedule_task/$', schedule_task),
]