
from django.conf.urls import url, include
from users import views
from rest_framework.routers import DefaultRouter

router = DefaultRouter()

router.register('info', views.UserViewSet, basename='web用户列表信息')
router.register('multiple', views.UserInfoViewSet, basename='批量操作web账号')
router.register('permission', views.PermissionViewSet, basename="web用户权限permission")

urlpatterns = [
    # url(r'^admin/', admin.site.urls),
    url(r'^', include(router.urls)),
    url(r'^checkDomainLicense/$', views.CheckDomainLicense.as_view(), name='CheckDomainLicense'),
    url(r'^activationDomain/$', views.ActivationDomain.as_view(), name='ActivationDomain'),
    url(r'^QRCodrActivationDomain/$', views.QRCodeActivationDomain.as_view(), name='QRCodeActivationDomain'),
    url(r'^login/$', views.ObtainAuthToken.as_view(), name='ObtainAuthToken'),
    url(r'^logout/$', views.Logout.as_view(), name='Logout'),

    url(r'^detail/$', views.User.as_view(), name='user-detail'),
    # url(r'^search/(?P<key>\S+)/$', views.SearchUser.as_view(), name='search-user'),

    # url(r'^createAdminUser/$', views.CreateAdminUser.as_view(), name='CreateAdminUser'),

    url(r'^userAdminSystem/$', views.UserAdminSystem.as_view(), name='AdminSystem'),
    url(r'^userAdminSystem/(?P<id>\S+)/$', views.UserAdminSystem.as_view(), name='admin-get-user'),

    url(r'^resetpassword/$', views.RestUserPassword.as_view(), name='RestUserPassword'),

    url(r'^set_org_global_switch/', views.set_org_global_switch),
    url(r'^org_global_switch/', views.org_global_switch),
]
