import logging

from rest_framework.views import exception_handler as drf_exception_handler
from rest_framework.views import Response
from rest_framework import status

logger = logging.getLogger(__name__)


def exception_handler(exc, context):
    response = drf_exception_handler(exc, context)
    if response is None:
        # drf 无法处理的 error
        # logger.info(context.__dict__())
        logger.error('%s-%s-%s' % (context['view'].__class__, context['request'].method, exc))
        return Response({
            'detail': '服务器错误',
        }, status=status.HTTP_500_INTERNAL_SERVER_ERROR, exception=True)
    return response


def api_error(code, msg):
    # e.g : return api_error(status.HTTP_400_BAD_REQUEST, error_msg)
    err_resp = {'error_msg': msg}
    return Response(err_resp, status=code)
