import datetime
import croniter

def time_transformation(date_str):
    """
    时间戳字符串转格式化后的字符串
    :param date_str: '1676511079' or  '1676511079,1676511090'
    :return: ['2023-02-16 01:31:19', '2023-02-16 01:31:30']
    """
    date_list = []
    if "," in date_str:
        date_list = date_str.split(",")
    else:
        date_list.append(date_str)

    return_list = []
    for date in date_list:
        return_list.append(datetime.datetime.strftime(datetime.datetime.fromtimestamp(int(date)), '%Y-%m-%d %H:%M:%S'))
    return_str = ",".join(return_list)
    return return_str


def utc_time_transformation(date_str):
    return_str = datetime.datetime.strptime(date_str, "%Y-%m-%dT%H:%M:%S.%f").strftime('%Y-%m-%d %H:%M:%S')
    return return_str


def run_get_next_time(sched):
    now = datetime.datetime.now()
    cron = croniter.croniter(sched, now)
    return [cron.get_next(datetime.datetime).strftime("%Y-%m-%d %H:%M")][0]


# print(run_get_next_time("* * * * *"))
