# -*- coding: utf-8 -*-
import os
import subprocess
import uuid
import re
import time

BASE_DIR = os.path.dirname(os.path.abspath(__file__))


def write_in(base_domain_name, domain_name, mac, ip, dns):
     # with open('{0}/conf/.env'.format(BASE_DIR), 'wt', encoding='utf-8') as f:
     #      f.write(env)
     if dns == '127.0.0.1':
          freeipa_command = 'ipa-server-install -U -r {DOMAIN_SERVER_RELM} --setup-dns --no-forwarder --no-hbac-allow'.format(
               DOMAIN_SERVER_RELM=domain_name.upper()
          )
     else:
          freeipa_command = 'ipa-server-install -U -r {DOMAIN_SERVER_RELM} --setup-dns --forwarder {DOMAIN_DNS} --no-hbac-allow'.format(
               DOMAIN_SERVER_RELM=domain_name.upper(),DOMAIN_DNS=dns
          )
     env = '''
#[DB]
DB_BACKEND=mysql
DB_NAME=nfs-domain
DB_USER=root
DB_PASS=123456
DB_HOST=db
DB_PORT=3306

#[DJANGO]
WEB_HOST=web
SECRET_KEY=#nfs@qcpg11x7gf8n&$s=@)wzx63vfwmt&rpu5uz=p@w$^ft(j
ALLOWED_HOSTS=*

#[SALT-API]
MASTER_HOST=master
MASTER_PORT=8000
SALT_URL=https://master:8000
SALT_AUTH=salt
SALT_PASSWD=123456

#[REDIS]
REDIS_HOST=redis
REDIS_PORT=6379
CELERY_BROKER_DB=1
CELERY_BACKEND_DB=2

#[DOMAIN_NAME]
DOMAIN_NAME=%s
DOMAIN_MAC=%s
DOMAIN_IP=%s
DOMAIN_DNS=%s


# FreeIPA Env
DOMAIN_SERVER_FQDN=%s
DOMAIN_SERVER_ADMIN=admin
DOMAIN_SERVER_ADMIN_PASSWD=nfschina@2023
DOMAIN_SERVER_RELM=%s
MAX_OPEN_FILES=30000

# Reprepro Env
REPREPRO_CONFIG_FOLDER=/opt/nfs-reporepo
REPREPRO_WEBSERVER_PORT=9778
REPREPRO_SSH_PORT=2322
KEY_REAL_NAME=NFSREPREPRO.COM
KEY_COMMENT=reprepro key
KEY_EMAIL=xuhy@nfschina.cn
HOSTNAME=%s
PROJECT_NAME=nfs-terminal
CODE_NAME=stretch
APTLY_IP=%s

# ELK
JOB_MANAGER_RPC_ADDRESS=jobmanager
TASK_MANAGER_NUMBER_OF_TASK_SLOTS=2
NFSDOMAIN_ES_IP_ADDR=%s
NFSDOMAIN_KAFKA_IP_ADDR=%s
NFSDOMAIN_DB_IP_ADDR=%s

# novnc
WEBSOCKIFY_ADDRESS=%s
VNC=x11vnc

# isofactory
MASTER_HOST=master
LOCAL_HOST=%s
MINION_NAME=isofactory
CMD=salt-minion

     ''' % (domain_name, mac, ip, dns, domain_name, base_domain_name.upper(), ip, ip, ip, ip, ip, ip, ip)

     nginx = '''
map $http_upgrade $connection_upgrade {
       default upgrade;
       '' close;
   }

upstream ws_servers {
    # 添加所有处理/ws/请求的后端服务器
    server %s:8081; # 这是另一个后端服务器
    server %s:8083; # 这是另一个后端服务器
    server %s:8084; # 这是另一个后端服务器
    server %s:8085; # 这是另一个后端服务器
    server %s:8086; # 这是另一个后端服务器
    # 如果有更多的服务器，继续添加
}

upstream web_servers {
    # 添加所有处理/web/请求的后端服务器
    server %s:8082; # 这是另一个后端服务器
    # 如果有更多的服务器，继续添加
}

server {
    listen 80;
    server_name %s;
    location / {
        proxy_pass         http://%s:10080;
    }
}


server {
    listen 80;
    server_name %s;
    proxy_set_header X-Forwarded-For $remote_addr;
    server_tokens off;
    #rewrite ^/ http://www.server.domain;
    
    location /cmdset/ {
        proxy_pass         http://ws_servers;
        proxy_read_timeout  3600;

        proxy_http_version 1.1;
        proxy_set_header Upgrade $http_upgrade;
        proxy_set_header Connection $connection_upgrade;

    }
    
    
    
    location /mainapi {
        proxy_pass         http://web_servers;
        #proxy_pass_header  Authorization;
        #proxy_pass_header  WWW-Authenticate;
        proxy_set_header   Host $host;
        proxy_set_header   X-Real-IP $remote_addr;
        proxy_set_header   X-Forwarded-For $proxy_add_x_forwarded_for;
        #proxy_set_header   X-Forwarded-Host $server_name;
        proxy_read_timeout  1200s;
        proxy_send_timeout  300;
        proxy_connect_timeout 300;
        proxy_buffers 16 512k;
        proxy_busy_buffers_size 512k;

        # used for view/edit office file via Office Online Server
        client_max_body_size 0;
        client_body_buffer_size 10m;
        client_body_timeout 300s;

        proxy_http_version 1.1;
        proxy_set_header Upgrade $http_upgrade;
        proxy_set_header Connection $connection_upgrade;

    }

    location /ws/ {
        proxy_pass         http://ws_servers/;
        proxy_read_timeout  3600;

        proxy_http_version 1.1;
        proxy_set_header Upgrade $http_upgrade;
        proxy_set_header Connection $connection_upgrade;

    }
    
     location /ipa/ui/ {
        rewrite ^/ipa/ui/(.*)$ https://%s/ipa/ui/ redirect;
    }
    
    location /vnc_lite.html {
        proxy_pass         http://%s:6688/vnc_lite.html;
        proxy_http_version 1.1;
        proxy_read_timeout 3600;
        proxy_set_header Host $host;
        proxy_set_header Upgrade $http_upgrade;
        proxy_set_header Connection "upgrade";

        proxy_set_header X-Forwarded-For $proxy_add_x_forwarded_for;
    }

    location /app/ {
        proxy_pass         http://%s:6688/app/;
    }
    location /vendor/ {
        proxy_pass         http://%s:6688/vendor/;
    }
    location /core/ {
        proxy_pass         http://%s:6688/core/;
    }

    location /websockify/ {
        proxy_pass         http://%s:6688/websockify/;
        proxy_http_version 1.1;
        proxy_read_timeout 3600;
        proxy_set_header Host $http_host;
        proxy_set_header Upgrade $http_upgrade;
        proxy_set_header Connection "upgrade";
    }
    
    location /webssh/ {
        proxy_pass         http://%s:8888/;
        proxy_http_version 1.1;
        proxy_read_timeout 3600;
        proxy_set_header Host $http_host;
        proxy_set_header Upgrade $http_upgrade;
        proxy_set_header Connection "upgrade";
    }
    
     location /pt/ {
        proxy_pass         http://%s:9000/;
        proxy_http_version 1.1;
        proxy_read_timeout 3600;
        proxy_set_header Upgrade $http_upgrade;
        proxy_set_header Connection $connection_upgrade;
    }
    
    location /aptly/ {
        proxy_pass         http://%s:9778/;
        proxy_http_version 1.1;
        proxy_read_timeout 3600;
        proxy_set_header Upgrade $http_upgrade;
        proxy_set_header Connection $connection_upgrade;
    }
      
     location /logsapi/ {
        proxy_pass         http://%s:9200/;
        proxy_http_version 1.1;
        proxy_set_header Upgrade $http_upgrade;
        proxy_set_header Connection $connection_upgrade;
    }
    
    location /mainweb {
        #proxy_set_header   X-Forwarded-Proto https;
        alias /opt/domain/nfs-domain-mainserver/frontend/dist;
        try_files $uri $uri/ /mainweb/index.html;
        if (-d $request_filename){
            rewrite [^/]$ $scheme://$http_host$uri/ permanent;
	    }
    }
}
     ''' % (ip,ip,ip,ip,ip,ip,domain_name,ip,ip,domain_name,ip,ip,ip,ip,ip,ip,ip,ip,ip)
     # kylin_v10_domain_list = 'deb [trusted=yes] http://{ip}:9778/kylin-v10/ kylin-v10 main'.format(ip=ip)
     # kylin_domain_list = 'deb [trusted=yes] http://{ip}:9778/kylin/ kylin main'.format(ip=ip)
     # nfs4_domain_list = 'deb [trusted=yes] http://{ip}:9778/nfs4/ nfs4 main'.format(ip=ip)
     # tiger_domain_list = 'deb [trusted=yes] http://{ip}:9778/tiger/ tiger main'.format(ip=ip)
     # uos_domain_list = 'deb [trusted=yes] http://{ip}:9778/uos/ uos main'.format(ip=ip)
      ## 给docker compolse使用，保证和yml文件在同一个目录下
     with open('{0}/.env'.format(BASE_DIR), 'wt', encoding='utf-8') as f:
          f.write(env)
     with open('{0}/docker/nginx-docker/etc/nginx/conf.d/nfs-domain-mainserver.conf'.format(BASE_DIR), 'wt', encoding='utf-8') as f:
          f.write(nginx)
     # with open('{0}/docker/salt-docker/srv/salt/file_system/kylin-v10/freeipa_client/apt/sources.list.d/domain.list'.format(BASE_DIR), 'wt', encoding='utf-8') as f:
     #      f.write(kylin_v10_domain_list)
     # with open('{0}/docker/salt-docker/srv/salt/file_system/kylin/freeipa_client/apt/sources.list.d/domain.list'.format(BASE_DIR), 'wt', encoding='utf-8') as f:
     #      f.write(kylin_domain_list)
     # with open('{0}/docker/salt-docker/srv/salt/file_system/nfs/freeipa_client/apt/sources.list.d/domain.list'.format(BASE_DIR), 'wt', encoding='utf-8') as f:
     #      f.write(nfs4_domain_list)
     # with open('{0}/docker/salt-docker/srv/salt/file_system/tiger/freeipa_client/apt/sources.list.d/domain.list'.format(BASE_DIR), 'wt', encoding='utf-8') as f:
     #      f.write(tiger_domain_list)
     # with open('{0}/docker/salt-docker/srv/salt/file_system/uos/freeipa_client/apt/sources.list.d/domain.list'.format(BASE_DIR), 'wt', encoding='utf-8') as f:
     #      f.write(uos_domain_list)


def load_images():
     nginx = subprocess.Popen("docker ps |grep nginx | grep -v 'grep' | awk '{print $2}'", shell=True,
                             stdout=subprocess.PIPE,
                             stderr=subprocess.PIPE)
     if nginx.wait() == 0:
          if nginx.stdout.readline().decode('utf-8') == 'nginx:latest':
               print("*** nginx exists ***")
          else:
               res = subprocess.Popen("docker load -i {0}/nginx.tar".format(BASE_DIR), shell=True,
                                      stdout=subprocess.PIPE,
                                      stderr=subprocess.PIPE)
               for l in res.stdout.readlines():
                    print(l.decode('utf-8'))

     mariadb = subprocess.Popen("docker ps |grep mariadb | grep -v 'grep' | awk '{print $2}'", shell=True,
                              stdout=subprocess.PIPE,
                              stderr=subprocess.PIPE)
     if mariadb.wait() == 0:
          if mariadb.stdout.readline().decode('utf-8') == 'mariadb:latest':
               print("*** mariadb exists ***")
          else:
               res = subprocess.Popen("docker load -i {0}/mariadb.tar".format(BASE_DIR), shell=True,
                                      stdout=subprocess.PIPE,
                                      stderr=subprocess.PIPE)
               for l in res.stdout.readlines():
                    print(l.decode('utf-8'))

     redis = subprocess.Popen("docker ps |grep redis | grep -v 'grep' | awk '{print $2}'", shell=True,
                                stdout=subprocess.PIPE,
                                stderr=subprocess.PIPE)
     if redis.wait() == 0:
          if redis.stdout.readline().decode('utf-8') == 'redis:5':
               print("*** redis exists ***")
          else:
               res = subprocess.Popen("docker load -i {0}/redis.tar".format(BASE_DIR), shell=True,
                                      stdout=subprocess.PIPE,
                                      stderr=subprocess.PIPE)
               for l in res.stdout.readlines():
                    print(l.decode('utf-8'))

     salt = subprocess.Popen("docker ps |grep nfschina/salt | grep -v 'grep' | awk '{print $2}'", shell=True,
                             stdout=subprocess.PIPE,
                             stderr=subprocess.PIPE)
     if salt.wait() == 0:
          if salt.stdout.readline().decode('utf-8') == 'nfschina/salt:latest':
               print("*** saltmaster exists ***")
          else:
               res = subprocess.Popen("docker load -i {0}/nfschina-salt.tar".format(BASE_DIR), shell=True,
                                       stdout=subprocess.PIPE,
                                       stderr=subprocess.PIPE)
               for l in res.stdout.readlines():
                    print(l.decode('utf-8'))

     domain = subprocess.Popen("docker ps |grep nfschina/domain | grep -v 'grep' | awk '{print $2}'", shell=True,
                              stdout=subprocess.PIPE,
                              stderr=subprocess.PIPE)
     if domain.wait() == 0:
          if domain.stdout.readline().decode('utf-8') == 'nfschina/domain:1.0':
               print("*** domain exists ***")
          else:
               res = subprocess.Popen("docker load -i {0}/nfschina-domain.tar".format(BASE_DIR), shell=True,
                                      stdout=subprocess.PIPE,
                                      stderr=subprocess.PIPE)
               for l in res.stdout.readlines():
                    print(l.decode('utf-8'))


def init_conf():
     node = uuid.getnode()
     base_mac = uuid.UUID(int=node).hex[-12:]
     mac = ':'.join([base_mac[m:m+2] for m in range(0, 11, 2)])
     print('--- 本机 MAC 地址为: {mac} ,请检查，若有误可手动输入，无误直接回车---'.format(mac=mac))
     while True:
          if not mac:
               print('--- 请输入本机 MAC 地址 ---')
               inp_mac = input('MAC：').strip(' ')
          else:
               inp_mac = input('MAC：').strip(' ')
          if inp_mac:
               mac = inp_mac
          if re.search('.*:', mac):
               pattern = re.compile(r"^\s*([0-9a-fA-F]{2}:){5}[0-9a-fA-F]{2}\s*$")
               if not pattern.match(mac):
                    print('--- MAC 地址格式错误 ---')
               else:
                    break
          else:
               print('--- MAC 地址格式错误 ---')

     dns = '127.0.0.1'
     try:
          with open('/etc/resolv.conf', mode='r') as f:
               cont = f.readlines()
               for c in cont:
                    DNS = re.search(
                         '^nameserver (?P<dns>((2((5[0-5])|([0-4]\d)))|([0-1]?\d{1,2}))(\.((2((5[0-5])|([0-4]\d)))|([0-1]?\d{1,2}))){3})$',
                         c
                    )
                    if DNS:
                         dns = DNS.group('dns')
                         break
     except Exception as e:
          print(e)
     # if DNS == '127.0.0.1':
     #      print('--- 请输入本机 DNS ---')
     # while True:
     #      if DNS == '127.0.0.1':
     #           DNS = input('DNS：').strip(' ')
     #      else:break

     print('--- 请输入本机 IP ---')
     while True:
          ip = input('IP：').strip(' ')
          if not ip:
               print('--- IP 不能为空 ---')
          else:
               break
     base_domain_name = 'nfsdomain.local'
     print('--- 域名默认为: {0} ---'.format(base_domain_name))
     print('--- 如需更改请输入并回车，无需更改则直接回车 ---')
     inp_domain_name = input('域名：').strip(' ')
     if inp_domain_name:
          base_domain_name = inp_domain_name
     sub_domain_name = 'server'
     print('--- 子域名默认为: {0} ---'.format(sub_domain_name))
     print('--- 如需更改请输入并回车，无需更改则直接回车 ---')
     inp_domain_name = input('子域名：').strip(' ')
     if inp_domain_name:
          sub_domain_name = inp_domain_name
     domain_name = '{0}.{1}'.format(sub_domain_name, base_domain_name)
     print('######################################')
     print('  MAC: {mac} '.format(mac=mac))
     print('  IP:  {ip} '.format(ip=ip))
     print('  DNS: {DNS} '.format(DNS=dns))
     print('  域名: {domain_name} '.format(domain_name=domain_name))
     print('######################################')
     is_ok = input('确认继续 或 退出 (yes / no) :')
     if is_ok != 'yes':
          print('--- 退出 ---')
          return
     print('--- 开始载入... ---')
     write_in(base_domain_name, domain_name, mac, ip, dns)
     time.sleep(5)
     # load_images()
     print('--- 载入成功 ---')


if __name__ == '__main__':
     # if len(sys.argv) == 1:
     #      raise ValueError('非法输入， 执行失败')
     init_conf()

'''
resolv.conf
# auto-generated by IPA installer
search fdtdm.local
nameserver 127.0.0.11

  freeipa:
    image: nfsdomain/ipa:v2
    environment:
      - IPA_SERVER_IP=60.10.60.203  # 副本服务器的IP
      - DNS=60.10.60.202  # 主DNS服务器,就是主服务器的IP
      - IPA_SERVER_HOSTNAME=shanghai.fdtdm.local  # 副服务器的FQDN
      - DOMAIN_SERVER_FQDN=shanghai.fdtdm.local  # 副服务器的FQDN
      - DOMAIN_SERVER_ADMIN=admin  # 主服务器的admin
      - DOMAIN_SERVER_ADMIN_PASSWD=nfschina@2023  # 主服务器的admin密码
      - MAX_OPEN_FILES=30000  # 文件描述符
      - IDSTART_RANGE=71000  # ID Range start
    hostname: shanghai
    domainname: shanghai.fdtdm.local  # 副服务器的FQDN
    extra_hosts:
      - "beijing.fdtdm.local:60.10.60.202"  # 主服务器的FQDN:IP
      - "shanghai.fdtdm.local:60.10.60.203"  # 副服务器的FQDN:IP
    tty: true
    stdin_open: true
    dns:
      - 60.10.60.203  # 副本服务器IP
      - 60.10.60.202  # 主服务器IP
      - 127.0.0.11
    tmpfs:
      - /run
      - /tmp
    restart: always
    volumes:
      - ./docker/freeipa-docker/data:/data:Z
      - /dev/urandom:/dev/random:ro
      - /etc/localtime:/etc/localtime:ro
      - /sys/fs/cgroup:/sys/fs/cgroup:ro
      - ./docker/freeipa-docker/ui:/usr/share/ipa/ui
    cap_add:
      - NET_ADMIN
    sysctls:
      - net.ipv6.conf.all.disable_ipv6=0
    ports:
      - "53:53"
      - "10080:80"
      - "443:443"
      - "389:389"
      - "636:636"
      - "53:53/udp"
      - "88:88"
      - "464:464"
      - "88:88/udp"
      - "464:464/udp"
      #- "123:123/udp"
    command:
      - ipa-replica-install
      - --domain=fdtdm.local # 域
      - --ip-address=60.10.60.203  # 副本服务器的IP
      - --server=beijing.fdtdm.local  # 主服务器FQDN
      - --admin-password=nfschina@2023
      - --no-dnssec-validation
      - --no-host-dns
      - --setup-dns
      - --setup-ca
      - --auto-forwarders
      - --allow-zone-overlap
      - --unattended
      - --force-join
      - --skip-conncheck
'''
