#!/bin/bash

set -e
curPath=$(readlink -f "$(dirname "$0")")
debian_path=/opt
pkg=$1
pkg_name=${pkg%.tar.gz}

start() {
    container_id=$(docker ps --filter "name=aptly" --format "{{.ID}}")
    docker cp $pkg $container_id:$debian_path
    docker exec -it $container_id sh -c "cd $debian_path && \
    tar -zxf $pkg && \
    ./aptly_create_publish.sh  $pkg_name && \
    rm -rf $pkg_name $pkg && \
    exit
    "
}


if echo "$1" | grep -q -E '\.tar.gz$'; then
    if [ -e $curPath/$pkg ]; then
        echo "..."
    else
        echo "$1 文件不存在"
        exit 1
    fi
    echo "开始更新 $pkg_name 请等待..."
    start
    echo "更新完成"
else
    echo "$1 不是有效的压缩包"
    exit 1
fi


exit 0
